/* Generated By:JavaCC: Do not edit this line. AlternateParser.java */
package com.zanthan.sequence.parser.alternate;

import java.io.*;
import java.util.*;

import com.zanthan.sequence.diagram.DiagramParserIface;
import com.zanthan.sequence.diagram.MethodExecution;
import com.zanthan.sequence.diagram.ObjectLifeLine;

import org.apache.log4j.Logger;

public class AlternateParser implements AlternateParserConstants {

  private static final Logger log = Logger.getLogger(AlternateParser.class);

  private DiagramParserIface diagram;

  private MethodExecution newMethodExecution;
  private Stack methodExecutionStack;
  private Map objectLifeLines;

  private void initialize() {
    if (log.isDebugEnabled()) {
        log.debug("initialize()");
    }
    newMethodExecution = null;
    methodExecutionStack = new Stack();
    objectLifeLines = new HashMap();
  }

  void setDiagram(DiagramParserIface diagram) {
    if (log.isDebugEnabled()) {
        log.debug("setDiagram(" + diagram + ")");
    }
    this.diagram = diagram;
  }

  void parse(Reader r) throws ParseException {
    if (log.isDebugEnabled()) {
        log.debug("parse(" + r + ")");
    }
    initialize();
    outermostMethodDescription();
  }

  void processSignature(ObjectIdentifier oi, MethodIdentifier mi, String returnValue) {
      if (log.isDebugEnabled()) {
          log.debug("processSignature(" + oi + ", " + mi + ", " + returnValue + ")");
      }
      String calledObjectName = oi.getName();
          ObjectLifeLine objectLifeLine = (ObjectLifeLine) objectLifeLines.get(calledObjectName);
      if (objectLifeLine == null) {
          objectLifeLine = diagram.newObjectLifeLine(calledObjectName, oi);
          objectLifeLines.put(calledObjectName, objectLifeLine);
          // Is this another root?
          if (methodExecutionStack.isEmpty()) {
              diagram.addRootObject(objectLifeLine);
          }
      }

      // Create the new method to be executed
      String calledMethodName = mi.getName();
      newMethodExecution = diagram.newMethodExecution(objectLifeLine, calledMethodName, mi);
      // See if we're currently executing a method. We won't be if this is a root
      if (!methodExecutionStack.isEmpty()) {
          // Get the current method being executed
          MethodExecution currentMethodExecution = (MethodExecution) methodExecutionStack.peek();
          // Add a call from the current method being executed to the new method
          currentMethodExecution.addCall(diagram.newCall(currentMethodExecution, newMethodExecution, returnValue, null));
      }
      // Add the new method execution to the object life line being called
      objectLifeLine.addMethodExecution(newMethodExecution);
  }

  String stripQuotes(String s, char quote) {
      String t = s.substring(1, s.length() - 1);
      if (t.indexOf(quote) == -1) {
        return t;
      }
      StringBuffer sb = new StringBuffer();
      int i = 0;
      while (i < t.length()) {
        char c = t.charAt(i);
        if (c == '\\' && t.charAt(i+1) == quote) {
          sb.append(quote);
          i += 2;
        } else {
          sb.append(c);
          i += 1;
        }
      }
      return sb.toString();
  }

  final public void outermostMethodDescription() throws ParseException {
    outermostSignature();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPEN_BRACE:
      methodBody();
      break;
    default:
      jj_la1[0] = jj_gen;
      ;
    }
  }

  final public void aMethodDescription() throws ParseException {
    signature();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STATEMENT_END:
      jj_consume_token(STATEMENT_END);
      break;
    case OPEN_BRACE:
      methodBody();
      break;
    default:
      jj_la1[1] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void outermostSignature() throws ParseException {
  String returnValue = null;
  ObjectIdentifier oi;
  MethodIdentifier mi = new MethodIdentifier();
  mi.setMethodName("foo");
    oi = objectIdentifier();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PERIOD:
      jj_consume_token(PERIOD);
      mi = methodIdentifier();
      break;
    default:
      jj_la1[2] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RETURN_MARKER:
      jj_consume_token(RETURN_MARKER);
      returnValue = returnValue();
      break;
    default:
      jj_la1[3] = jj_gen;
      ;
    }
      processSignature(oi, mi, returnValue);
  }

  final public void signature() throws ParseException {
  String returnValue = null;
  ObjectIdentifier oi;
  MethodIdentifier mi;
    oi = objectIdentifier();
    jj_consume_token(PERIOD);
    mi = methodIdentifier();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RETURN_MARKER:
      jj_consume_token(RETURN_MARKER);
      returnValue = returnValue();
      break;
    default:
      jj_la1[4] = jj_gen;
      ;
    }
      processSignature(oi, mi, returnValue);
  }

  final public void methodBody() throws ParseException {
    jj_consume_token(OPEN_BRACE);
      methodExecutionStack.push(newMethodExecution);
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STEREOTYPE:
      case DOUBLE_QUOTE_STRING:
      case SINGLE_QUOTE_STRING:
      case UNQUOTED_STRING:
      case 18:
        ;
        break;
      default:
        jj_la1[5] = jj_gen;
        break label_1;
      }
      aMethodDescription();
    }
    jj_consume_token(CLOSE_BRACE);
      methodExecutionStack.pop();
  }

  final public ObjectIdentifier objectIdentifier() throws ParseException {
  String s;
  ObjectIdentifier oi = new ObjectIdentifier();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DOUBLE_QUOTE_STRING:
    case SINGLE_QUOTE_STRING:
    case UNQUOTED_STRING:
      s = objectName();
          oi.setObjectName(s);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 18:
        s = className();
          oi.setClassName(s);
        break;
      default:
        jj_la1[6] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STEREOTYPE:
        s = stereotype();
          oi.setStereotype(s);
        break;
      default:
        jj_la1[7] = jj_gen;
        ;
      }
      break;
    case 18:
      s = className();
          oi.setClassName(s);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STEREOTYPE:
        s = stereotype();
          oi.setStereotype(s);
        break;
      default:
        jj_la1[8] = jj_gen;
        ;
      }
      break;
    case STEREOTYPE:
      s = stereotype();
          oi.setStereotype(s);
      break;
    default:
      jj_la1[9] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
          {if (true) return oi;}
    throw new Error("Missing return statement in function");
  }

  final public MethodIdentifier methodIdentifier() throws ParseException {
  MethodIdentifier mi = new MethodIdentifier();
  String s;
  Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ITERATION_MARKER:
      jj_consume_token(ITERATION_MARKER);
          mi.setIteration(true);
      break;
    default:
      jj_la1[10] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CONDITION:
      t = jj_consume_token(CONDITION);
          mi.setCondition(t.image);
      break;
    default:
      jj_la1[11] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DOUBLE_QUOTE_STRING:
    case SINGLE_QUOTE_STRING:
    case UNQUOTED_STRING:
      s = stringIdentifier();
          mi.setMethodName(s);
      break;
    case STEREOTYPE:
      s = stereotype();
          mi.setStereotype(s);
      break;
    default:
      jj_la1[12] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case METHOD_ARGUMENTS:
      t = jj_consume_token(METHOD_ARGUMENTS);
      mi.setArguments(t.image);
      break;
    default:
      jj_la1[13] = jj_gen;
      ;
    }
          {if (true) return mi;}
    throw new Error("Missing return statement in function");
  }

  final public String objectName() throws ParseException {
  String s;
    s = stringIdentifier();
          {if (true) return s;}
    throw new Error("Missing return statement in function");
  }

  final public String className() throws ParseException {
  String s;
    jj_consume_token(18);
    s = stringIdentifier();
          {if (true) return ":" + s;}
    throw new Error("Missing return statement in function");
  }

  final public String returnValue() throws ParseException {
  String s;
    s = stringIdentifier();
          {if (true) return s;}
    throw new Error("Missing return statement in function");
  }

  final public String stereotype() throws ParseException {
  Token t;
    t = jj_consume_token(STEREOTYPE);
          {if (true) return t.image;}
    throw new Error("Missing return statement in function");
  }

  final public String stringIdentifier() throws ParseException {
  Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case UNQUOTED_STRING:
      t = jj_consume_token(UNQUOTED_STRING);
          {if (true) return t.image;}
      break;
    case DOUBLE_QUOTE_STRING:
      t = jj_consume_token(DOUBLE_QUOTE_STRING);
          {if (true) return stripQuotes(t.image, '"');}
      break;
    case SINGLE_QUOTE_STRING:
      t = jj_consume_token(SINGLE_QUOTE_STRING);
          {if (true) return stripQuotes(t.image, '\'');}
      break;
    default:
      jj_la1[14] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  public AlternateParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[15];
  static private int[] jj_la1_0;
  static {
      jj_la1_0();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {0x40,0x140,0x200,0x400,0x400,0x53800,0x40000,0x800,0x800,0x53800,0x20,0x8000,0x13800,0x4000,0x13000,};
   }

  public AlternateParser(java.io.InputStream stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new AlternateParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 15; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 15; i++) jj_la1[i] = -1;
  }

  public AlternateParser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new AlternateParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 15; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 15; i++) jj_la1[i] = -1;
  }

  public AlternateParser(AlternateParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 15; i++) jj_la1[i] = -1;
  }

  public void ReInit(AlternateParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 15; i++) jj_la1[i] = -1;
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;

  public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[19];
    for (int i = 0; i < 19; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 15; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 19; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

}
